import java.net.*;
import java.io.*;
import java.util.Vector;


public class FTPDataSocket{

	private String strIP;
	private int intPort;
	private Socket socketData;
	private BufferedReader brRead;
	private BufferedWriter bwWrite;
	private FTPclient SocketControl;

	public  FTPDataSocket(FTPclient sc) throws IOException
	{
		SocketControl = sc;
		SocketControl.sendCommand("PASV");
		String strLine = SocketControl.getReply();
		int intStart = strLine.indexOf("(");
		int intEnd = strLine.indexOf(")");
		//System.out.println(strLine+","+intStart+","+intEnd);

		String strArray[] = strLine.substring(intStart+1,intEnd).split(",");
		strIP = strArray[0] + "." + strArray[1] + "." + strArray[2] + "." +strArray[3];
		intPort = (Integer.parseInt(strArray[4])<<8) + Integer.parseInt(strArray[5]);


		socketData = new Socket(strIP,intPort);	
		brRead = new BufferedReader(new InputStreamReader(socketData.getInputStream()));
		bwWrite = new BufferedWriter(new OutputStreamWriter(socketData.getOutputStream()));
	}
	//List
	public String[] read() throws IOException
	{
		String strLine = null;
		Vector veResult = new Vector();
		while((strLine = brRead.readLine())!=null)
			veResult.add(strLine);
		String [] strResult = (String[])veResult.toArray(new String[0]);
		socketData.close();
		SocketControl.getReply();
		return strResult;
	}	
	//UASCII
	public byte[] readASCII() throws IOException
	{
		String strLine = null;
		String newline = System.getProperty("line.separator");
		StringBuffer strbufResult = new StringBuffer();
		while((strLine = brRead.readLine())!=null)
			//strbufResult.append(strLine.replaceAll("\r\n","\n"));
			strbufResult.append(strLine+newline);
		byte [] byResult = strbufResult.toString().getBytes();
		brRead.close();
		socketData.close();
		SocketControl.getReply();
		return byResult;
	}
	//UIMAGE
	public byte[] readIMAGE() throws IOException
	{
		int ch;
		StringBuffer strbufResult = new StringBuffer();
		while((ch = brRead.read())!=-1)
			strbufResult.append((char)ch);
		byte [] byResult = strbufResult.toString().getBytes();
		brRead.close();
		socketData.close();
		SocketControl.getReply();
		return byResult;
	}
	//Wɮ
	public void  write(BufferedReader br) throws IOException
	{
		int ch;
		if(SocketControl.getFileType() == FTPclient.typeA)
			while ((ch = br.read()) != -1)
			{
				if ((char)ch == '\n')
					bwWrite.write("\r\n",0,2);
				else
					bwWrite.write(ch);
			}
		else
		{
			while ( (ch = br.read()) != -1 )
				bwWrite.write(ch);
		}
		bwWrite.close();
		socketData.close();
		SocketControl.getReply();
	}
}
