import java.io.*;

import java.util.*;

import java.awt.*;
import java.awt.event.*;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;

import java.awt.dnd.*;

import java.text.DateFormat;


import javax.swing.*;

public class FakeFTP extends JFrame implements ActionListener,MouseListener,DropTargetListener {

	FileCellRenderer lfcr = null;/*{{{*/
	// renderer for local files

	JList jlistLocal = null;
	// JList to display local files

	JList jlistRemote = null;
	// JList to display remote files

	JList popupAt = null;
	//  where the popup menu at

	Box boxM = null;
	Box boxTop = null;
	Box boxBottom = null;

	JTextArea textMsg = null;
	TextAreaWriter logMsg = null;
	JTextField textIP = null;
	JTextField textPort = null;
	JTextField textUser = null;
	JPasswordField textPass = null;
	JButton btnConnect = null;
	ButtonGroup bgType = null;
	JPopupMenu popup= null;

	DefaultListModel listLocalFile = null;
	// hold local files' information

	DefaultListModel listRemoteFile = null;
	// hold local files' information

	Icon iconFile,iconSelFile,iconDir,iconSelDir;
	// icons for rendering

	boolean  boolConnected = false;
	// whether connected or not

	int intType = AUTO;
	// transfer type

	static final int AUTO = 0;
	static final int ASCII = 1;
	static final int IMAGE = 2;

	String strPath = "";

	Comparator compFile = null;
	// comparator for file and dirs

	FTPclient ftp = null;
	// inner ftp object

	// special item for local cdup
	LocalFileListItem LOCAL_UP = new LocalFileListItem("..",true,0L,new Date(0L)) 
	{
		public String getShortName()
		{
			return "..";
		}
	};

	// special item for remote cdup
	RemoteFileListItem REMOTE_UP = new RemoteFileListItem("..",true,0L,new Date(0L))
	{
		public String getShortName()
		{
			return "..";
		}
	};


	// table for text files
	HashSet TextTable = new HashSet();;
	// exts of text files 
	static final String [] TextFileExts = {".txt",".java",".bat",".html",".htm",".sh",".c",".cpp"};/*}}}*/

	public static void main(String args[])/*{{{*/
	{
		FakeFTP app = new FakeFTP();

		splashFrame splash = new splashFrame(app,new ImageIcon("splash.png"));
		app.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}/*}}}*/

	public FakeFTP() /*{{{*/
	{
		// initial table
		TextTable.addAll(Arrays.asList(TextFileExts));
		// initialization 
		iconDir = new ImageIcon(".\\dir.png");
		iconSelDir = new ImageIcon(".\\seldir.png");
		iconFile = new ImageIcon(".\\file.png");
		iconSelFile = new ImageIcon(".\\selfile.png");

		lfcr = new FileCellRenderer(iconDir,iconSelDir,iconFile,iconSelFile);
		listLocalFile = new DefaultListModel();
		listRemoteFile = new DefaultListModel();
		jlistLocal = new JList(listLocalFile);
		jlistRemote = new JList(listRemoteFile);
		textMsg = new JTextArea(5,40);
		logMsg = new TextAreaWriter(textMsg);
		textIP = new JTextField(15);
		textPort = new JTextField("21",3);
		textUser = new JTextField(12);
		textPass = new JPasswordField(10);
		btnConnect = new JButton("Connect");
		bgType = new ButtonGroup();
		JRadioButton btnTemp1 = new JRadioButton("Ascii");
		JRadioButton btnTemp2 = new JRadioButton("Binary");
		JRadioButton btnTemp3 = new JRadioButton("Auto");
		popup= new JPopupMenu();
		boxM = Box.createVerticalBox();
		boxTop = Box.createHorizontalBox();
		boxBottom = Box.createHorizontalBox();

		// comparator for files and dirs
		compFile = new Comparator() {
			public int compare(Object o1,Object o2)
			{
				if ( !(((FileListItem)o1).isDir() ^ ((FileListItem)o2).isDir()) )
					return ((FileListItem)o1).getShortName().compareTo(((FileListItem)o2).getShortName());
				else
					return ((FileListItem)o1).isDir() ? -1 : 1;
			}
			public boolean equals(Object obj)
			{
				return false;
			}
		};

		// set properties for objects
		jlistLocal.setCellRenderer(lfcr);
		jlistLocal.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		jlistLocal.addMouseListener(this);
		jlistLocal.setDragEnabled(true);
		jlistLocal.setDropTarget(new DropTarget(jlistLocal,this));

		jlistRemote.setCellRenderer(lfcr);
		jlistRemote.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		jlistRemote.addMouseListener(this);
		jlistRemote.setDragEnabled(true);
		jlistRemote.setDropTarget(new DropTarget(jlistRemote,this));

		textMsg.setEditable(false);

		btnConnect.setActionCommand("Connect");
		btnConnect.addActionListener(this);


		btnTemp1.setActionCommand("A");
		btnTemp1.addActionListener(this);
		btnTemp2.setActionCommand("I");
		btnTemp2.addActionListener(this);
		btnTemp3.setActionCommand("P");
		btnTemp3.addActionListener(this);
		btnTemp3.setSelected(true);
		bgType.add(btnTemp1);
		bgType.add(btnTemp2);
		bgType.add(btnTemp3);

		// MenuItem:Delete
		JMenuItem itemTemp = new JMenuItem("Delete");
		itemTemp.addActionListener(this);
		itemTemp.setActionCommand("delete");
		popup.add(itemTemp);

		// MenuItem:Rename
		itemTemp = new JMenuItem("Rename");
		itemTemp.addActionListener(this);
		itemTemp.setActionCommand("rename");
		popup.add(itemTemp);

		// MenuItem:mkdir
		itemTemp = new JMenuItem("Mkdir");
		itemTemp.addActionListener(this);
		itemTemp.setActionCommand("mkdir");
		popup.add(itemTemp);


		boxTop.setMaximumSize(new Dimension(600,25));
		boxTop.setPreferredSize(new Dimension(600,25));
		boxTop.setMinimumSize(new Dimension(600,25));

		JScrollPane sp1 = new JScrollPane(textMsg);
		sp1.setMaximumSize(new Dimension(600,120));
		sp1.setPreferredSize(new Dimension(600,120));
		sp1.setMinimumSize(new Dimension(600,120));
		sp1.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLoweredBevelBorder(),"Messages"));

		JScrollPane sp2 = new JScrollPane(jlistLocal);
		sp2.setMaximumSize(new Dimension(300,300));
		sp2.setPreferredSize(new Dimension(300,300));
		sp2.setMinimumSize(new Dimension(300,300));
		sp2.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLoweredBevelBorder(),"Local Files"));

		JScrollPane sp3 = new JScrollPane(jlistRemote);
		sp3.setMaximumSize(new Dimension(300,300));
		sp3.setPreferredSize(new Dimension(300,300));
		sp3.setMinimumSize(new Dimension(300,300));
		sp3.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLoweredBevelBorder(),"Remote Files"));

		// add objects to where they should be
		boxM.add(boxTop);
		boxM.add(sp1);
		boxM.add(boxBottom);
		boxTop.add(new JLabel("IP"));
		boxTop.add(textIP);
		boxTop.add(new JLabel("PORT"));
		boxTop.add(textPort);
		boxTop.add(new JLabel("USER"));
		boxTop.add(textUser);
		boxTop.add(new JLabel("PASSWORD"));
		boxTop.add(textPass);
		boxTop.add(btnConnect);
		boxTop.add(btnTemp1);
		boxTop.add(btnTemp2);
		boxTop.add(btnTemp3);
		boxBottom.add(sp2);
		boxBottom.add(sp3);
		getContentPane().add(boxM);

		try 
		{
			updateLocalList();
		} catch (Exception e) {/*do nothing*/}

		pack();
		setResizable(false);

	}/*}}}*/

	// process action events 
	public void actionPerformed(ActionEvent e)/*{{{*/
	{
		// connect or disconnect
		if ( e.getActionCommand().equals("Connect") )
		{
			if ( !boolConnected )
			{
				try 
				{
					ftp = new FTPclient(textIP.getText(),Integer.parseInt(textPort.getText()),logMsg);
					// login
					ftp.login(textUser.getText(),String.valueOf(textPass.getPassword()));
					// list
					updateRemoteList();
					// connected
					setConnected(true);
				} catch (IOException ee) {
					// connection fail
					setConnected(false);
					try {
						logMsg.write("Connection fail\n");
					if ( ftp != null )
							ftp.quit();
					} catch (Exception eee) {/*do nothing*/}
				}
			}
			else
			{
				setConnected(false);
				try
				{
					ftp.quit();
				} catch (Exception ee) {/*do nothing*/}
			}
		}
		// binary mode
		else if ( e.getActionCommand().equals("I") )
		{
			intType = IMAGE;
		}
		// ascii mode
		else if ( e.getActionCommand().equals("A") )
		{
			intType = ASCII;
		}
		// auto mode
		else if ( e.getActionCommand().equals("P") )
		{
			intType = AUTO;
		}
		// rename
		else if ( e.getActionCommand().equals("rename") )
		{
			try
			{
				FileListItem itemTemp = null;
				String strName;
				if ( popupAt == jlistLocal )
				{
					itemTemp = (FileListItem)popupAt.getSelectedValue();
					// no selection
					if ( itemTemp == null )
						return;
					strName = JOptionPane.showInputDialog(null,"rename to");
					if ( strName == null )
						return;
					File fileOld = new File(itemTemp.getName());
					File fileNew = new File(strPath+"\\"+strName);
					if ( fileNew.exists() )
						JOptionPane.showMessageDialog(null,"file exists");
					else
						fileOld.renameTo(fileNew);
					updateLocalList();
				}
				else if ( popupAt == jlistRemote )
				{
					itemTemp = (FileListItem)popupAt.getSelectedValue();
					// no selection
					if ( itemTemp == null )
						return;
					strName = JOptionPane.showInputDialog(null,"rename to");
					if ( strName == null )
						return;
					ftp.rename(itemTemp.getShortName(),strName);
					updateRemoteList();
				}
			} catch ( Exception ee) {/*do nothing*/}
		}
		// delete
		else if ( e.getActionCommand().equals("delete") )
		{
			try
			{
				Object [] itemTemp = null;
				int confirm;
				if ( popupAt == jlistLocal )
				{
					itemTemp = popupAt.getSelectedValues();
					// no selection
					if ( itemTemp == null )
						return;
					confirm = JOptionPane.showConfirmDialog(null,"Are you sure to delete \""+((FileListItem)itemTemp[0]).getShortName()+"...\"");
					if ( confirm == JOptionPane.YES_OPTION )
					{
						File fileTemp = null;
						for ( int i = 0 ; i < itemTemp.length ; i++ )
						{
							fileTemp = new File(((FileListItem)itemTemp[i]).getName());
							fileTemp.delete();
						}
					}
					updateLocalList();
				}
				else if ( popupAt == jlistRemote )
				{
					itemTemp = popupAt.getSelectedValues();
					// no selection
					if ( itemTemp == null )
						return;
					confirm = JOptionPane.showConfirmDialog(null,"Are you sure to delete \""+((FileListItem)itemTemp[0]).getShortName()+"...\"");
					if ( confirm == JOptionPane.YES_OPTION )
						for ( int i = 0 ; i < itemTemp.length ; i++ )
							if ( ((FileListItem)itemTemp[i]).isDir() )
								ftp.rmd(((FileListItem)itemTemp[i]).getShortName());
							else
								ftp.dele(((FileListItem)itemTemp[i]).getShortName());
					updateRemoteList();
				}
			} catch ( Exception ee) {/*do nothing*/}
		}
		// mkdir
		else if ( e.getActionCommand().equals("mkdir") )
		{
			try 
			{
				String strName = null;
				if ( popupAt == jlistLocal )
				{
					strName = JOptionPane.showInputDialog(null,"name");
					if ( strName == null )
						return;
					File fileTemp = new File(strPath+"\\"+strName);
					if ( fileTemp.exists() )
						JOptionPane.showMessageDialog(null,"directory exists");
					else
						fileTemp.mkdir();
					updateLocalList();
				}
				else if ( popupAt == jlistRemote )
				{
					strName = JOptionPane.showInputDialog(null,"name");
					if ( strName == null )
						return;
					ftp.mkd(strName);
					updateRemoteList();
				}
			} catch ( Exception ee) {/*do nothing*/}
		}
	}/*}}}*/

	// process mouse events

	// enter directory
	public void mouseClicked(MouseEvent e) 
	{
		// events from local file list
		if ( e.getSource() == jlistLocal )/*{{{*/
		{
			// double click left button
			if ( e.getClickCount() == 2 && e.getButton() == e.BUTTON1)
			{
				LocalFileListItem itemTemp= (LocalFileListItem)jlistLocal.getSelectedValue();
				// if is directory => enter directory
				if ( itemTemp.isDir() )
				{
					try
					{
						// list roots
						if ( itemTemp.getName().equals(".") )
							strPath = "";
						// list files in directory
						else
							strPath = itemTemp.getName();
						// set Parent name
						LOCAL_UP.setName(itemTemp.getParentName());
						updateLocalList();
					} catch (Exception ee) {/*do nothing*/}
				}
				else 
				{
					Shell.exec(itemTemp.getName());
				}
			}
		}/*}}}*/
		// events from local files list
		else if ( e.getSource() == jlistRemote )/*{{{*/
		{
			// double click
			if ( e.getClickCount() == 2 && e.getButton() == e.BUTTON1 )
			{
				RemoteFileListItem itemTemp = (RemoteFileListItem)jlistRemote.getSelectedValue();
				// if is directory => enter directory
				if ( itemTemp.isDir() )
				{
					try
					{
						if ( itemTemp.getShortName().equals("..") )
							ftp.cdup();
						else
							ftp.cwd(itemTemp.getShortName());
						updateRemoteList();
					} catch (Exception ee) {/*do nothing*/}
				}
			}
		}/*}}}*/
	}

	// handle popup menu
	public void mousePressed(MouseEvent e)/*{{{*/
	{
		// click right button
		if (e.isPopupTrigger()) 
		{
			popup.show(e.getComponent(),e.getX(),e.getY());
			popupAt = (JList)e.getSource();
		}
	}

	public void mouseReleased(MouseEvent e)
	{
		if (e.isPopupTrigger()) 
		{
			popup.show(e.getComponent(),e.getX(),e.getY());
			popupAt = (JList)e.getSource();
		}
	}/*}}}*/

	// handle drop
	public	void drop(DropTargetDropEvent dtde) /*{{{*/
	{
		// if not connected , exit
		if ( !boolConnected )
			return;
		try 
		{
			String strImport = (String)dtde.getTransferable().getTransferData(DataFlavor.stringFlavor);
			String strTemp = strImport.substring(0,2);
			StringTokenizer stTemp = new StringTokenizer(strImport);

			// drop in remote list => upload
			if ( dtde.getDropTargetContext().getComponent() == jlistRemote && strTemp.equals("L:") )
			{
				jlistRemote.setEnabled(false);
				while (stTemp.hasMoreTokens())
					putFile(stTemp.nextToken());
				jlistRemote.setEnabled(true);
				updateRemoteList();
			}
			// drop in local list => download
			if ( dtde.getDropTargetContext().getComponent() == jlistLocal && strTemp.equals("R:") )
			{
				jlistRemote.setEnabled(false);
				while (stTemp.hasMoreTokens())
					getFile(stTemp.nextToken());
				jlistRemote.setEnabled(true);
				updateLocalList();
			}
		} catch (Exception e) {/*do nothing*/}
	}/*}}}*/

	// do nothing
	public void mouseEntered(MouseEvent e) {/*do nothing*/}/*{{{*/
	public void mouseExited(MouseEvent e) {/*do nothing*/}
	public	void dragEnter(DropTargetDragEvent dtde) {/* do nothing*/}
	public	void dragExit(DropTargetEvent dte) {/*do nothing*/}
	public	void dragOver(DropTargetDragEvent dtde) {/*do nothing*/}
	public	void dropActionChanged(DropTargetDragEvent dtde) {/*do nothing*/} /*}}}*/

	void putFile(String strUpload) throws IOException/*{{{*/
	{
		switch (intType)
		{
		case ASCII:
			// ascii
			ftp.setType(ftp.typeA);
		case IMAGE:
			// image
			ftp.setType(ftp.typeI);
		default:
			//auto 
			String strTemp = strUpload.substring(strUpload.indexOf(".")).toLowerCase();
			if (TextTable.contains(strTemp))
				ftp.setType(ftp.typeA);
			else
				ftp.setType(ftp.typeI);
		}
		String strPath2 = (strPath.indexOf(strPath.length()-1) == '\\' ? strPath : strPath+"\\");
		//System.out.println("PUT:"+strPath2+strUpload.substring(2));
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(new File(strPath2+strUpload.substring(2)))));
		ftp.stor(strUpload.substring(2),br);
	}/*}}}*/

	void getFile(String strDownload) throws IOException/*{{{*/
	{
		switch (intType)
		{
		case ASCII:
			// ascii
			ftp.setType(ftp.typeA);
		case IMAGE:
			// image
			ftp.setType(ftp.typeI);
		default:
			//auto 
			String strTemp = strDownload.substring(strDownload.indexOf(".")).toLowerCase();
			if (TextTable.contains(strTemp))
				ftp.setType(ftp.typeA);
			else
				ftp.setType(ftp.typeI);
		}
		String strPath2 = (strPath.indexOf(strPath.length()-1) == '\\' ? strPath : strPath+"\\");
		//System.out.println("GET:"+strPath2+strDownload.substring(2));
		byte [] buf = ftp.retr(strDownload.substring(2));
		FileOutputStream os = new FileOutputStream(new File(strPath2+strDownload.substring(2)));
		os.write(buf);
		os.close();
	}/*}}}*/

	RemoteFileListItem parseList(String strLine,String pwd)/*{{{*/
	{
		StringTokenizer stTemp = new StringTokenizer(strLine);
		RemoteFileListItem rf = new RemoteFileListItem();
		// test if Dir
		rf.setDir(stTemp.nextToken().charAt(0)=='d');
		// dismiss
		stTemp.nextToken();
		// dismiss owner
		stTemp.nextToken();
		// dismiss group
		stTemp.nextToken();
		// set size
		rf.setSize(Long.parseLong(stTemp.nextToken()));
		// set Date
		try {
			Calendar cal = Calendar.getInstance();
			String mon = stTemp.nextToken();
			String day = stTemp.nextToken();
			String year = stTemp.nextToken();
			if ( year.indexOf(":") != -1 )
			{
				cal.setTime(new Date());
				cal.set(cal.get(cal.YEAR),parseMonth(mon),Integer.parseInt(day));
			}
			else
			{
				cal.set(Integer.parseInt(year),parseMonth(mon),Integer.parseInt(day));
			}
			rf.setDate(cal.getTime());
		} catch (Exception e) {/*do nothing*/}
		// set file name
		rf.setName(pwd+"/"+stTemp.nextToken());
		return rf;
	}/*}}}*/

	int parseMonth(String mon)/*{{{*/
	{
		if ( mon.compareToIgnoreCase("jan") == 0)
			return 0;
		else if ( mon.compareToIgnoreCase("feb") == 0)
			return 1;
		else if ( mon.compareToIgnoreCase("mar") == 0)
			return 2;
		else if ( mon.compareToIgnoreCase("apr") == 0)
			return 3;
		else if ( mon.compareToIgnoreCase("may") == 0)
			return 4;
		else if ( mon.compareToIgnoreCase("jun") == 0)
			return 5;
		else if ( mon.compareToIgnoreCase("jul") == 0)
			return 6;
		else if ( mon.compareToIgnoreCase("aug") == 0)
			return 7;
		else if ( mon.compareToIgnoreCase("sep") == 0)
			return 8;
		else if ( mon.compareToIgnoreCase("oct") == 0)
			return 9;
		else if ( mon.compareToIgnoreCase("nom") == 0)
			return 10;
		else if ( mon.compareToIgnoreCase("dec") == 0)
			return 11;
		return 0; // never happen
	}/*}}}*/

	void ItemArray2LocalList(LocalFileListItem [] items)/*{{{*/
	{
		listLocalFile.clear();
		listLocalFile.addElement(LOCAL_UP);
		for ( int i = 0 ; i < items.length ; i++ )
			listLocalFile.addElement(items[i]);
	}/*}}}*/

	void ItemArray2RemoteList(RemoteFileListItem [] items)/*{{{*/
	{
		listRemoteFile.clear();
		listRemoteFile.addElement(REMOTE_UP);
		for ( int i = 0 ; i < items.length ; i++ )
			listRemoteFile.addElement(items[i]);
	}/*}}}*/

	LocalFileListItem [] toLocalFileListItem( File [] fileSrc)/*{{{*/
	{
		LocalFileListItem [] flistTemp = new LocalFileListItem[fileSrc.length];
		if ( strPath.equals("") )
			for ( int i = 0 ; i < fileSrc.length ; i++ )
				flistTemp[i] = new LocalFileListItem(fileSrc[i].getAbsolutePath(),true,0,new Date());
		else
			for ( int i = 0 ; i < fileSrc.length ; i++ )
				flistTemp[i] = new LocalFileListItem(fileSrc[i].getAbsolutePath(),!fileSrc[i].isFile(),fileSrc[i].length(),new Date(fileSrc[i].lastModified()));
		return flistTemp;
	}/*}}}*/

	RemoteFileListItem [] toRemoteFileListItem(String [] strSrc,String pwd)/*{{{*/
	{
		RemoteFileListItem [] flistTemp = new RemoteFileListItem[strSrc.length];
		for ( int i = 0 ; i < strSrc.length ; i++ )
			flistTemp[i] = parseList(strSrc[i],pwd);
		return flistTemp;
	}/*}}}*/

	void updateLocalList() throws IOException/*{{{*/
	{
		File [] fileTemp = null;

		// list roots
		if ( strPath.equals("") )
				fileTemp = File.listRoots();
		// list files in directory
		else
			fileTemp = new File(strPath).listFiles();
		/*
		Vector listTemp = new Vector(Arrays.asList(fileTemp));
		for (int  i = 0; i < listTemp.size() ; i++ )
		{
			File f = (File)listTemp.elementAt(i);
			if (!f.canRead())
				listTemp.remove(f);
		}
		fileTemp = (File [])listTemp.toArray(new File [0]);
		*/
		LocalFileListItem [] lflistTemp = toLocalFileListItem( fileTemp );
		Arrays.sort(lflistTemp,compFile);
		ItemArray2LocalList(lflistTemp);
	}/*}}}*/

	void updateRemoteList() throws IOException/*{{{*/
	{
		String [] strTemp = ftp.list();
		RemoteFileListItem [] rflistTemp = toRemoteFileListItem(strTemp,ftp.pwd());
		Arrays.sort(rflistTemp,compFile);
		ItemArray2RemoteList(rflistTemp);
	}/*}}}*/

	void setConnected(boolean b)/*{{{*/
	{
		if (b)
		{
			btnConnect.setText("Disconnect");
			textIP.setEnabled(false);
			textPort.setEnabled(false);
			textUser.setEnabled(false);
			textPass.setEnabled(false);
			boolConnected = true;
		}
		else
		{
			listRemoteFile.clear();
			btnConnect.setText("Connect");
			textIP.setEnabled(true);
			textPort.setEnabled(true);
			textUser.setEnabled(true);
			textPass.setEnabled(true);
			boolConnected = false;
		}
	}/*}}}*/

	File [] getLocalFilesInDir(File dir)/*{{{*/
	{
		if ( !dir.isDirectory() )
			return (new File [0]); 
		LinkedList llistResult = new LinkedList();
		File [] fileChilds = dir.listFiles();
		for ( int i = 0 ; i < fileChilds.length ; i++ )
			if ( fileChilds[i].isDirectory())
			{
				llistResult.add(fileChilds[i]);
				llistResult.addAll(Arrays.asList(getLocalFilesInDir(fileChilds[i])));
			}
			else
				llistResult.add(fileChilds[i]);
		return (File[])llistResult.toArray(new File[0]);
	}
/*}}}*/

	class TextAreaWriter extends Writer/*{{{*/
	{
		JTextArea text = null;
		TextAreaWriter(JTextArea t)
		{
			text = t;
		}
		public void close() throws IOException
		{
		}
		public  void flush()  throws IOException
		{
		}
		public void write(char[] cbuf)  throws IOException
		{
			write(cbuf,0,cbuf.length);
		}
		public  void write(char[] cbuf, int off, int len)  throws IOException
		{
			text.append(String.copyValueOf(cbuf,off,len));
		}
		public void write(int c)  throws IOException
		{
			text.append(String.valueOf(c));
		}
		public void write(String str)  throws IOException
		{
			write(str,0,str.length());
		}
		public void write(String str, int off, int len)  throws IOException
		{
			text.append(str.substring(off,off+len));
		}
	}/*}}}*/

}
 
class splashFrame extends JFrame/*{{{*/
{
	private java.util.Timer timer= new java.util.Timer();
	private JFrame frameNext = null;
	splashFrame(JFrame frame,Icon img)
	{
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension d = tk.getScreenSize();
		setBounds((int)(d.getWidth()-500)/2,(int)(d.getHeight()-295)/2,500,295);
		setUndecorated(true);
		frameNext = frame;
		getContentPane().setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
		getContentPane().add(new JLabel(img));
		setVisible(true);
		pack();
		timer.schedule( new CountDown(), 5000 );
	}


	private class CountDown extends TimerTask
	{
			public void run()
			{
				timer.cancel();
				setVisible(false);
				dispose();
				frameNext.setVisible(true);
			}
	}
}/*}}}*/
