
import java.text.*;
import java.awt.*;

import javax.swing.*;

public class FileCellRenderer extends JPanel implements ListCellRenderer 
{
	private Icon iconDir = null;
	private Icon iconSelDir = null;
	private Icon iconFile = null;
	private Icon iconSelFile = null;
	private JLabel labelIcon = null;
	private JTextField textFilename = null;
	private JTextField textSize= null;
	private JTextField textDate = null;

	final Color colorBlue = new Color(132);
	public FileCellRenderer(Icon dir,Icon seldir,Icon file,Icon selfile)
	{
		// never paint behind the others
		setOpaque(true);
		iconDir = dir;
		iconSelDir = seldir;
		iconFile = file;
		iconSelFile = selfile;

		textFilename = new JTextField(10);
		textSize = new JTextField(5);
		textDate = new JTextField(8);
		textFilename.setBorder(null);
		textFilename.setEditable(false);
		textSize.setBorder(null);
		textSize.setEditable(false);
		textSize.setHorizontalAlignment(JTextField.RIGHT);
		textDate.setBorder(null);
		textDate.setEditable(false);
		textDate.setHorizontalAlignment(JTextField.RIGHT);
		labelIcon = new JLabel();

		setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
		add(labelIcon);
		add(textFilename);
		add(textSize);
		add(textDate);
	}
	public Component getListCellRendererComponent(JList list,Object value,int index,boolean iss,boolean chf)
	{
		FileListItem item = (FileListItem) value;
		// get date of file
		String strDate = DateFormat.getDateInstance().format(item.getDate());
		// get size of file
		String strSize = NumberFormat.getInstance().format(item.getSize());
		// short name of file
		textFilename.setText(item.getShortName());
		// if it is selected , draw border and change BG color
		setLabelProperty(iss);
		Icon icon = null;
		if (iss)
			if (item.isDir())
				icon = iconSelDir;
			else
				icon = iconSelFile;
		else
			if (item.isDir())
				icon = iconDir;
			else
				icon = iconFile;
		labelIcon.setIcon(icon);
		textSize.setText(strSize);
		textDate.setText(strDate);
		return this;
	}

	// set properties for 3 texts when selected or not selected
	private void setLabelProperty(boolean b)
	{
		if (b)
		{
			textFilename.setBackground(colorBlue);
			textFilename.setForeground(Color.white);
			textSize.setBackground(colorBlue);
			textSize.setForeground(Color.white);
			textDate.setBackground(colorBlue);
			textDate.setForeground(Color.white);
			setBackground(colorBlue);
		}
		else
		{
			textFilename.setBackground(Color.white);
			textFilename.setForeground(Color.black);
			textSize.setBackground(Color.white);
			textSize.setForeground(Color.black);
			textDate.setBackground(Color.white);
			textDate.setForeground(Color.black);
			setBackground(Color.white);
		}
	}
}
